from django.core.management import color_style
from edc_sites.single_site import SingleSite

style = color_style()

fqdn = "inte.clinicedc.org"


# site_id, name, **kwargs
all_sites = {
    "uganda": (
        SingleSite(
            101,
            "bugamba",
            country_code="ug",
            country="uganda",
            domain=f"bugamba.ug.{fqdn}",
        ),
        SingleSite(
            102,
            "bwizibwera",
            country_code="ug",
            country="uganda",
            domain=f"bwizibwera.ug.{fqdn}",
        ),
        SingleSite(
            103,
            "kinoni",
            country_code="ug",
            country="uganda",
            domain=f"kinoni.ug.{fqdn}",
        ),
        SingleSite(
            104,
            "ruhoko",
            country_code="ug",
            country="uganda",
            domain=f"ruhoko.ug.{fqdn}",
        ),
        SingleSite(
            105,
            "kyazanga",
            country_code="ug",
            country="uganda",
            domain=f"kyazanga.ug.{fqdn}",
        ),
        SingleSite(
            106,
            "bukulula",
            country_code="ug",
            country="uganda",
            domain=f"bukulula.ug.{fqdn}",
        ),
        SingleSite(
            107,
            "kojja",
            country_code="ug",
            country="uganda",
            domain=f"kojja.ug.{fqdn}",
        ),
        SingleSite(
            108,
            "mpigi",
            country_code="ug",
            country="uganda",
            domain=f"mpigi.ug.{fqdn}",
        ),
        SingleSite(
            109,
            "namayumba",
            country_code="ug",
            country="uganda",
            domain=f"namayumba.ug.{fqdn}",
        ),
        SingleSite(
            110,
            "buwambo",
            country_code="ug",
            country="uganda",
            domain=f"buwambo.ug.{fqdn}",
        ),
        SingleSite(
            111,
            "kajjansi",
            country_code="ug",
            country="uganda",
            domain=f"kajjansi.ug.{fqdn}",
        ),
        SingleSite(
            112,
            "tikalu",
            country_code="ug",
            country="uganda",
            domain=f"tikalu.ug.{fqdn}",
        ),
        SingleSite(
            113,
            "namulonge",
            country_code="ug",
            country="uganda",
            domain=f"namulonge.ug.{fqdn}",
        ),
        SingleSite(
            114,
            "kasanje",
            country_code="ug",
            country="uganda",
            domain=f"kasanje.ug.{fqdn}",
        ),
        SingleSite(
            115,
            "kasangati",
            country_code="ug",
            country="uganda",
            domain=f"kasangati.ug.{fqdn}",
        ),
        SingleSite(
            116,
            "sekiwunga",
            country_code="ug",
            country="uganda",
            domain=f"sekiwunga.ug.{fqdn}",
        ),
        SingleSite(
            117,
            "muduma",
            country_code="ug",
            country="uganda",
            domain=f"muduma.ug.{fqdn}",
        ),
        SingleSite(
            118,
            "kyamulibwa",
            country_code="ug",
            country="uganda",
            domain=f"kyamulibwa.ug.{fqdn}",
        ),
    ),
    "tanzania": (
        SingleSite(
            201,
            "bagamoyo",
            title="Bagamoyo District hospital",
            country_code="tz",
            country="tanzania",
            domain=f"bagamoyo.tz.{fqdn}",
        ),
        SingleSite(
            202,
            "buguruni",
            title="Buguruni Health Centre",
            country_code="tz",
            country="tanzania",
            domain=f"buguruni.tz.{fqdn}",
        ),
        SingleSite(
            203,
            "rugambwa",
            title="Cardinal Rugambwa Hospital",
            country_code="tz",
            country="tanzania",
            domain=f"rugambwa.tz.{fqdn}",
        ),
        SingleSite(
            204,
            "consolata",
            title="Consolata Sisters Dispensary",
            country_code="tz",
            country="tanzania",
            domain=f"consolata.tz.{fqdn}",
        ),
        SingleSite(
            205,
            "kinondoni",
            title="Kinondoni Hospital",
            country_code="tz",
            country="tanzania",
            domain=f"kinondoni.tz.{fqdn}",
        ),
        SingleSite(
            206,
            "kisarawe",
            title="Kisarawe District Hospital",
            country_code="tz",
            country="tanzania",
            domain=f"kisarawe.tz.{fqdn}",
        ),
        SingleSite(
            207,
            "magomeni",
            title="Magomeni Health Centre",
            country_code="tz",
            country="tanzania",
            domain=f"magomeni.tz.{fqdn}",
        ),
        SingleSite(
            208,
            "mbagala",
            title="Mbagala Rangi Tatu Hospital",
            country_code="tz",
            country="tanzania",
            domain=f"mbagala.tz.{fqdn}",
        ),
        SingleSite(
            209,
            "mnazi",
            title="Mnazi Mmoja Hospital",
            country_code="tz",
            country="tanzania",
            domain=f"mnazi.tz.{fqdn}",
        ),
        SingleSite(
            210,
            "sinza",
            title="Sinza Hospital",
            country_code="tz",
            country="tanzania",
            domain=f"sinza.tz.{fqdn}",
        ),
        SingleSite(
            211,
            "vincent",
            title="St.Vincent Health Centre",
            country_code="tz",
            country="tanzania",
            domain=f"vincent.tz.{fqdn}",
        ),
        SingleSite(
            212,
            "tambuka",
            title="Tambuka Reli Dispensary",
            country_code="tz",
            country="tanzania",
            domain=f"tambuka.tz.{fqdn}",
        ),
        SingleSite(
            213,
            "tandale",
            title="Tandale Health Centre",
            country_code="tz",
            country="tanzania",
            domain=f"tandale.tz.{fqdn}",
        ),
        SingleSite(
            214,
            "tegeta",
            title="Tegeta Mission Centre",
            country_code="tz",
            country="tanzania",
            domain=f"tegeta.tz.{fqdn}",
        ),
        SingleSite(
            215,
            "temeke",
            title="Temeke Regional Referral Hospital",
            country_code="tz",
            country="tanzania",
            domain=f"temeke.tz.{fqdn}",
        ),
        SingleSite(
            216,
            "yombo",
            title="Yombo Vituka Health Centre",
            country_code="tz",
            country="tanzania",
            domain=f"yombo.tz.{fqdn}",
        ),
    ),
}
